package com.gic.haoban.manage.service.dao.mapper.licence;

import com.gic.haoban.manage.api.dto.qdto.licence.LicenceOrderPageQDTO;
import com.gic.haoban.manage.service.entity.licence.TabHaobanLicenceOrder;
import org.apache.ibatis.annotations.Param;

import javax.xml.crypto.Data;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author jx
 * @since 2023-03-09
 */
public interface TabHaobanLicenceOrderMapper {

    /**
     * 获取订单详情
     *
     * @param orderId
     * @return
     */
    TabHaobanLicenceOrder selectById(@Param("orderId") Long orderId);

    /**
     * 新增订单
     *
     * @param tabHaobanLicenceOrder
     * @return
     */
    Integer insert(TabHaobanLicenceOrder tabHaobanLicenceOrder);

    /**
     * 删除订单
     *
     * @param orderId
     * @return
     */
    Integer deleteById(@Param("orderId") Long orderId);

    /**
     * 跟新订单状态
     *
     * @param orderId
     * @param type
     * @return
     */
    Integer updateLicenceOrderType(@Param("orderId") Long orderId, @Param("type") Integer type);

    /**
     * 跟新企业微信订单状态
     *
     * @param orderId
     * @param type
     * @return
     */
    Integer updateQywxOrderType(@Param("orderId") Long orderId, @Param("type") Integer type);

    /**
     * 上次订单支付凭证
     *
     * @param orderId
     * @param voucher
     * @return
     */
    Integer uploadLicenceOrderVoucher(@Param("orderId") Long orderId, @Param("voucher") String voucher);

    /**
     * 根据wxEnterpriseId查询企业是否存在未支付订单
     *
     * @param wxEnterpriseId
     * @return order_id
     */
    String selectByWxEnterpriseId(@Param("wxEnterpriseId") String wxEnterpriseId);

    /**
     * 分页查询订单列表
     *
     * @param licenceOrderPageQDTO
     * @return
     */

    List<TabHaobanLicenceOrder> getLicenceOrderPage(LicenceOrderPageQDTO licenceOrderPageQDTO);

    Integer saveTransactionCode(@Param("orderId") Long orderId, @Param("transactionCode") String transactionCode,
                                @Param("prepayId") String prepayId, @Param("wxOrderId") String wxOrderId, @Param("payTime") Date payTime);

    /**
     * 获取订单详情
     *
     * @param transactionId 微信订单id
     * @return
     */
    TabHaobanLicenceOrder selectByTransactionId(@Param("transactionId") String transactionId);

    /**
     *
     * @param qywxOrderId 企业微信订单id
     * @param wxEnterpriseId
     * @return
     */
    TabHaobanLicenceOrder selectByQywxOrderId(@Param("qywxOrderId") String qywxOrderId,@Param("wxEnterpriseId") String wxEnterpriseId);

    /**
     * 保存企业微信订单id
     *
     * @param orderId
     * @param qywxOrderId
     * @return
     */
    Integer saveQywxOrderId(@Param("orderId") Long orderId, @Param("qywxOrderId") String qywxOrderId);

    List<String> getTransactionIdList(@Param("transactionId") String transactionId,@Param("wxEnterpriseId") String wxEnterpriseId);

    List<String> getQywxOrderId(@Param("qywxOrderId") String qywxOrderId,@Param("wxEnterpriseId") String wxEnterpriseId);

}
